/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#include <string.h>

#include "ei.h"
#include "putget.h"

int ei_encode_ref(char *buf, int *index, const erlang_ref *p)
{
  char *s = buf + *index;
  char *s0 = s;
  int len = strlen(p->node);
  
  if (!buf) s += 9 + len;
  else {
    put8(s,ERL_REFERENCE_EXT);

    /* first the nodename */
    put8(s,ERL_ATOM_EXT);

    put16be(s,len);
  
    memmove(s, p->node, len);
    s += len;

    /* now the integers */
    put32be(s,p->id);
    put8(s,(p->creation & 0x03));
  }
  
  *index += s-s0;
  
  return 0;
}

